<template>
  <div class="container mx-auto py-10 h-auto md:w-4/5 w-11/12 px-6">
    <div
      class="w-full h-full rounded border-2 border-gray-300 p-8 relative bg-gray-200"
    >
      <div class="relative">
        <input
          v-model="searchData"
          type="text"
          class="text-gray-700 h-14 w-full pr-8 pl-5 rounded z-0 focus:shadow focus:outline-none"
          placeholder="Search anything..."
        />
      </div>
      <div id="js-catalog-no-result" class="hidden text-center my-8">
        Le jeu n'a pas été trouvé dans notre base.
      </div>
      <div id="js-catalog-loader" class="hidden text-center my-8">
        <font-awesome-icon icon="spinner" size="10x" spin />
      </div>
      <div
        class="mt-8 grid sm:grid-cols-1 md:grid-cols-2 lg:grid-cols-3 xl:grid-cols-4 gap-8 relative"
      >
        <div v-for="(game, key) in games" :key="`${key}`" class="flex">
          <Card :image_url="game.image" :title="game.name" :description="game.studio ? game.studio.name : null" :id="game.id" />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import Card from "./Card"
export default {
  name: "Catalog",
  components: {
    Card
  },
  data() {
    return {
      moved: true,
      games: [],
      searchData: "",
      urlGetGames: `https://${window.location.hostname}:8443/games`,
      urlSearchGames: `https://${window.location.hostname}:8443/games/search`
    }
  },
  inject: ["createAlert"],
  beforeMount() {
    fetch(this.urlGetGames, {
      headers: {
        Accept: "application/json",
        "Content-Type": "application/json"
      },
      method: "GET"
    })
      .then((res) => {
        if (res.ok) {
          return res.json()
        } else {
          throw new Error("Something went wrong")
        }
      })
      .then((data) => {
        if (data) {
          this.games = data
        } else {
          this.createAlert({
            color: "red",
            text: "Une erreur est survenue",
            icon: "times"
          })
        }
      })
      .catch(() => {
        this.createAlert({
          color: "red",
          text: "Une erreur est survenue",
          icon: "times"
        })
      })
  },
  watch: {
    searchData: async function(value) {
      var noResultDiv = document.getElementById("js-catalog-no-result")
      var loaderDiv = document.getElementById("js-catalog-loader")

      loaderDiv.classList.add("is-visible")

      if (noResultDiv.classList.contains("is-visible")) {
        noResultDiv.classList.remove("is-visible")
      }

      fetch(this.urlSearchGames + `?search=${value}`, {
        headers: {
          Accept: "application/json",
          "Content-Type": "application/json",
        },
        method: "GET"
      })
        .then((res) => {
          if (res.ok) {
            return res.json()
          } else {
            throw new Error("Something went wrong")
          }
        })
        .then((data) => {
          this.games = data
          loaderDiv.classList.remove("is-visible")

          if (data.length === 0) {
            noResultDiv.classList.add("is-visible")
          }
        })
        .catch(() => {
          this.createAlert({
            color: "red",
            text: "Une erreur est survenue",
            icon: "times"
          })
        })
    }
  }
}
</script>

<style scoped>
.is-visible {
  display: block;
}
</style>
